import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Goods, GoodsParam } from './model';
import { OPEN_API_URL } from '@/config/setting';

/**
 * 分页查询商品
 */
export async function pageGoods(params: GoodsParam) {
  const res = await request.get<ApiResult<PageResult<Goods>>>(
    OPEN_API_URL + '/shop/goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品列表
 */
export async function listGoods(params?: GoodsParam) {
  const res = await request.get<ApiResult<Goods[]>>(
    OPEN_API_URL + '/shop/goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品
 */
export async function addGoods(data: Goods) {
  const res = await request.post<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品
 */
export async function updateGoods(data: Goods) {
  const res = await request.put<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品
 */
export async function removeGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品
 */
export async function removeBatchGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/goods/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
